package test;

import com.vaadin.data.Item;
import com.vaadin.data.fieldgroup.FieldGroup;
import com.vaadin.data.fieldgroup.PropertyId;
import com.vaadin.data.validator.BeanValidator;
import com.vaadin.ui.CustomComponent;
import com.vaadin.ui.FormLayout;
import com.vaadin.ui.TextField;


public class MyForm extends CustomComponent implements Item.Viewer {

    @PropertyId("name")
    TextField tf = new TextField("TextField");

    Item newDataSource;

    public MyForm () {
		tf.setImmediate(true);
        FormLayout fl = new FormLayout();
        fl.addComponent(tf);
        tf.addValidator(new BeanValidator(Bean.class,"name"));
		setCompositionRoot(fl);
    }

    @Override
    public void setItemDataSource(Item newDataSource) {
        this.newDataSource = newDataSource;
        FieldGroup fg = new FieldGroup(newDataSource);
        fg.bindMemberFields(this);
		fg.setBuffered(false);
    }

    @Override
    public Item getItemDataSource() {
        return newDataSource;
    }
}
